Page MenuHomeFreeBSD

6/7 vfs: rework vnode list management
ClosedPublic

Authored by mjg on Jan 1 2020, 10:58 PM.

Details

Summary

The current notion of an active vnode is eliminated.

Vnodes transition between 0<->1 hold counts all the time and the
associated traversal between different lists induces significant
scalability problems in certain workloads.

Introduce a global list containing all allocated vnodes. They get
unlinked only when UMA reclaims memory and are only requeued when
use hold count reaches 0.

Sample result from an incremental make -s -j 104 bzImage on tmpfs:
stock: 118.55s user 3649.73s system 7479% cpu 50.382 total
patched: 122.38s user 1780.45s system 6242% cpu 30.480 total

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

mjg created this revision.Jan 1 2020, 10:58 PM

I see why my previous comments about list duplication were not totally germane because much of the duplicated code was removed by this diff.

mjg updated this revision to Diff 66295.Jan 3 2020, 12:34 PM
  • rebase
mjg retitled this revision from 4/5 vfs: rework vnode list management to 6/7 vfs: rework vnode list management.Jan 5 2020, 4:07 AM
mjg updated this revision to Diff 66449.Jan 7 2020, 5:13 PM
  • rebase
  • annotate freevnodes with __exclusive_cache_line
mjg updated this revision to Diff 66627.Jan 11 2020, 4:26 PM
  • rebase
jeff accepted this revision.Jan 12 2020, 7:55 PM
This revision is now accepted and ready to land.Jan 12 2020, 7:55 PM
This revision was automatically updated to reflect the committed changes.